package com.jiayue.passback.job;

import com.jiayue.passback.constants.CommonStant;
import com.jiayue.passback.entity.SysParameter;
import com.jiayue.passback.service.SystemParameterService;
import com.jiayue.passback.util.SFTPUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.Date;

@Slf4j
@Component
public class sftpJob {

    private final SystemParameterService systemParameterService;
    public sftpJob(SystemParameterService systemParameterService){
        this.systemParameterService =systemParameterService;
    }
    // 去对端拿文件parameter
    @Scheduled(cron = "0 0/1 * * * ?")
	public void sftpJob(){
        log.info("---------------------开始执行sftp下载文件定时任务---------------------");
        SysParameter parameter  = systemParameterService.getParameter();
        String sftpParameter =parameter.getSysValue();
        // 根据用户名获取密码
        String host = sftpParameter.split(CommonStant.CHARACTER_COLON)[0];
        String userName = sftpParameter.split(CommonStant.CHARACTER_COLON)[1];
        String password = sftpParameter.split(CommonStant.CHARACTER_COLON)[2];
        int port = Integer.valueOf(sftpParameter.split(CommonStant.CHARACTER_COLON)[3]);
        String path = sftpParameter.split(CommonStant.CHARACTER_COLON)[4];
        String savePath = sftpParameter.split(CommonStant.CHARACTER_COLON)[5];
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMdd");
        String dayStr = dateFormat.format(new Date());
        // 查询当前文件是否已经下载过
        String bakPath = savePath.replace("new", "bak"+File.separator + dayStr);

        File filePath = new File(bakPath);
        if (!filePath.exists()){
            filePath.mkdirs();
            log.info("扫描文件夹不存在，系统自动创建该文件夹！");
        }
        Collection<File> files = FileUtils.listFiles(filePath, new String[]{"CIME"}, false);
        if (files.size() > 0){
         for (File file : files){
             if (file.getName().contains(dayStr)) {
                 log.info("已经下载过该文件，无需再次下载");
                 continue;
             }
             SFTPUtil.loginAndDownload(userName, password,host,port,path,savePath);
         }
        }else {
            SFTPUtil.loginAndDownload(userName, password,host,port,path,savePath);
        }

        log.info("-----------------------sftp执行下载定时任务完成----------------------");
	}
}
