package com.jiayue.passback.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jiayue.passback.constants.CommonStant;
import com.jiayue.passback.entity.ElectricField;
import com.jiayue.passback.entity.SysParameter;
import com.jiayue.passback.mapper.ElectricFieldMapper;
import com.jiayue.passback.mapper.SystemParameterMapper;
import com.jiayue.passback.service.ElectricFieldService;
import com.jiayue.passback.service.SystemParameterService;
import com.jiayue.passback.util.JsonResultUtil;
import org.springframework.stereotype.Service;

@Service
public class SystemParameterServiceImpl extends ServiceImpl<SystemParameterMapper, SysParameter> implements SystemParameterService {

    private final SystemParameterMapper systemParameterMapper;

    public SystemParameterServiceImpl(SystemParameterMapper systemParameterMapper){
        this.systemParameterMapper = systemParameterMapper;
    }
    @Override
    public SysParameter getParameter() {
        // 设置参数
        QueryWrapper<SysParameter> wrapper = new QueryWrapper();
        wrapper.eq("C_SYS_KEY", "SFTP_PARAMETER");
        SysParameter systemParameter = systemParameterMapper.selectOne(wrapper);
        if (systemParameter == null || systemParameter.getSysValue() == null || "".equals(systemParameter.getSysValue()) || systemParameter.getSysValue().split(CommonStant.CHARACTER_COLON).length != 6) {
            log.error("系统参数SFTP_PARAMETER未配置或配置错误");
            return null;
        }
        return systemParameter;
    }
}
